PSystem ps;
Arcball arcball;

int PARTICLES_Z = 5;
int PARTICLES_Y = 4;
int PARTICLES_X = 10;

float unitLength = 30;

Particle[][][] particles;

void setup() {
  size(500, 500);
  ps = (PSystem)loadPlugin("PSystem");
  arcball = (Arcball)loadPlugin("Arcball");
  ps.setGravity(0);
  ps.defaultSpringRestLength = unitLength;
  ps.defaultSpringStrength = 0.5;
  
  
  makeGrid();
}

void loop() {
  translate(width/4, height/2);
  background(#99CCCC);
  translate(width/4, 0);
  arcball.run();
  translate(-width/4, 0);
  ps.draw();
}

void makeGrid() {
  particles = new Particle[PARTICLES_X][PARTICLES_Y][PARTICLES_Z];

  for (int x = 0; x < PARTICLES_X; x++) {
    for (int z = 0; z < PARTICLES_Z; z++) {
      for (int y = 0; y < PARTICLES_Y; y++) {
        particles[x][y][z] = new Particle();
        ps.addParticle(particles[x][y][z]);
        particles[x][y][z].setPos(unitLength*x,unitLength*y,unitLength*z);
      }
    }
  }
}
